/*
 *  Copyright 2019-2020 Zheng Jie
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
package com.youchain.businessdata.service;

import com.youchain.businessdata.domain.AgvTask;
import com.youchain.businessdata.domain.Task;
import com.youchain.businessdata.service.dto.AgvTaskDto;
import com.youchain.businessdata.service.dto.AgvTaskQueryCriteria;
import org.springframework.data.domain.Pageable;
import java.util.Map;
import java.util.List;
import java.io.IOException;
import javax.servlet.http.HttpServletResponse;

/**
 * @author baobinglin
 * @website https://eladmin.vip
 * @description 服务接口
 * @date 2023-08-18
 **/
public interface AgvTaskService {

    /**
     * 查询数据分页
     *
     * @param criteria 条件
     * @param pageable 分页参数
     * @return Map<String, Object>
     */
    Map<String, Object> queryAll(AgvTaskQueryCriteria criteria, Pageable pageable);

    /**
     * 查询所有数据不分页
     *
     * @param criteria 条件参数
     * @return List<AgvTaskDto>
     */
    List<AgvTaskDto> queryAll(AgvTaskQueryCriteria criteria);

    /**
     * 根据ID查询
     *
     * @param id ID
     * @return AgvTaskDto
     */
    AgvTaskDto findById(Integer id);

    /**
     * 创建
     *
     * @param resources /
     * @return AgvTaskDto
     */
    AgvTaskDto create(AgvTask resources);

    /**
     * 编辑
     *
     * @param resources /
     */
    void update(AgvTask resources);

    /**
     * 多选删除
     *
     * @param ids /
     */
    void deleteAll(Integer[] ids);

    /**
     * 导出数据
     *
     * @param all      待导出的数据
     * @param response /
     * @throws IOException /
     */
    void download(List<AgvTaskDto> all, HttpServletResponse response) throws IOException;

    /**
     * 发送货架搬运接口任务
     *
     * @param agvTasks
     * @return
     */
    String sendAgvTaskImpl(AgvTask agvTasks);

    /**
     * 发送料箱搬运接口任务
     *
     * @param agvTasks
     * @return
     */
    String sendAgvTaskLXImpl(List<AgvTask> agvTasks);

    String containerIn(String containerCode, String position);

    /**
     * 容器出场
     *
     * @param containerCode-容器编号
     * @return
     */
    String containerOut(String containerCode);

    /**
     * 读取输送线、流利式货架状态
     *
     * @param conveyorId-输送线编号
     * @return
     */
    void getConveyorState(String conveyorId);

    AgvTask toEntity(AgvTaskDto agvTaskDto);

    /**
     * 任务回报更新状态
     *
     * @param agvTask
     * @param status
     * @param
     */
    void agvTaskCallback(AgvTask agvTask, Task task, String status);

    void agvTaskCallback(AgvTask agvTask, String status, String containerCode);


//    List<AgvTask> findById(List<Integer> ids);

    double queryBillCodeSum(String billCode);

    /**
     * 根据组号+料箱号招找到对应的AGV
     *
     * @param jobForce-任务组号
     * @param containerCode-容器号
     * @return
     */
    AgvTask findByjobCode(String jobForce, String containerCode);

    /**
     * 根据组号+找到对应的AGV集合
     *
     * @param jobForce-任务组号
     * @return
     */
    List<AgvTask> findByjobCode(String jobForce);

    /**
     *
     * @param status
     * @param type
     * @return
     */
    List<AgvTask> queryByAgvTask(String status,String type);

    void closeAgvTask(Long id);
}
